#include "sets.h"
#include <iostream.h>

unsigned long BinTreeNode::counter = 0;


BinTreeNode::BinTreeNode (int d)
{
  left = right = 0;
  data = d;
  counter++;
}

BinTreeNode::~BinTreeNode ()
{
  --counter;
}

Set::~Set()
{
  clear();
}

#ifdef TREE

Set::Set ()
{
  root = 0;
  size = 0;
}

bool insert (PBinTreeNode &t, int x)
{
  if (t == 0)
    {
      t = new BinTreeNode(x);
      return true;
    }
  else if (t->data == x)
    {
      return false;
    }
  else if (x < t->data)
    return insert (t->left, x);
  else
    return insert (t->right, x);
}

      

Set& Set::add (int x)
{
  if (insert (root, x))
     size++;
  return *this;  /* this==puntero al objeto actual */
}


bool Set::member (int x) const
{
  BinTreeNode *t = root;
  while (t != 0)
    {
      if (t->data == x)
	return true;
      else if (x < t->data)
        t = t->left;
      else
	t = t->right;
    }
  return false;
}



void deleteAll (PBinTreeNode& t)
{
  if (t != 0)
    {
      deleteAll(t->left);
      deleteAll(t->right);
      delete t;
      t = 0;
    }
}


Set& Set::clear()
{
  size = 0;
  deleteAll(root);
  return *this;
}

////////////////////////////////////////////////////


/********************* lo mio *********************/


////////////////////////////////////////////////////



//copia en profundidad del rbol binario
//t puntero raiz rbol destino
//ts puntero raiz rbol origen

void Set::copia (PBinTreeNode &t,const PBinTreeNode &ts)
{	
	if (ts!=0){                                         //pregunta si el rbol origen no est vacio
		t = new BinTreeNode(ts->data);                  //agrega un nuevo nodo copiando el dato del rbol origen
		copia(t->left,ts->left);                        //recorre recursivamente hacia la izq.
		copia(t->right,ts->right);                      //recorre recursivamente hacia la der.
  	}
}	
/******************************************************/

//se genera el constructor de copia para la estructura set

Set::Set (const Set& s)
{
	root = 0;                                           //se inicializa el puntero a la raiz
  size = s.size;                                        //copia el tamao del set
	copia(this->root,s.root);                           //llama a el mtodo copia (copia del rbol en profundidad).
}

/******************************************************/

//implementacin de la sobrecarga de operador asignacin


Set& Set::operator= (const Set &s)
{
clear();              									//eliminacin de todos los punteros del set de origen
size=s.size;                                            //copia el tamao del set
PBinTreeNode ts=s.root;                                 //se define un puntero al nodo raz
copia(this->root,s.root);                               //llama a el mtodo copia (copia del rbol en profundidad).
return *this;                                           // se retorna una referencia al objeto

}



////////////////////////////////////////////////////


/********************* lo mio *********************/


////////////////////////////////////////////////////


#else




Set::Set ()
{
  size = 0;
}


Set& Set::add (int x)
{
  if (!member(x))
    {
      members[size] = x;
      size++;
    }
  return *this;
}


bool Set::member (int x) const
{
  for (int i = 0; i < size; i++)
    if (x == members[i])
      return true;
  return false;
}


Set& Set::clear()
{
  size = 0;
  return *this;
}


#endif

